   Tento manuál se vzathuje ke Speech Dispatcher, verze 0.7-beta3.
Jedná se v¹ak pouze o u¾ivatelskou èást dokumentace a upozoròujeme, ¾e
tento pøeklad ji¾ není aktuální!  Poskytujeme jej s tím, ¾e mo¾ná bude
u¾iteèný a to zejména v sekcích, které popisují obecné koncepty a
my¹lenky projektu, a to tìm, kteøí si nemohou pøeèíst anglickou
dokumentaci.  Nikdo by nicménì nemìl spoléhat na technické detaily zde
uvedené, proto¾e mnoho vìcí je ji¾ dnes jinak.

   Copyright (C) 2001, 2002, 2003 Brailcom, o.p.s.

     Dáváme povolení kopírovat, distribuovat a/nebo modifikovate tento
     dokument pod podmínkami GNU Free Documentation License, Verze 1.2
     nebo jakékoliv novìj¹í verze vydané Free Software Foundation; bez
     jakýchkoliv Invariant Sections (nemìnných sekcí), bez Front-Cover
     Texts (texty na pøední stranì obálky) a bez Back-Cover Texts
     (texty na zadní stranì obálky).  Kopie této licence je pøilo¾ena v
     sekci nazvané ,,GNU Free Documentation License".

1 Úvod
******

1.1 Motivace
============

Projekt Speech Dispatcher se sna¾í poskytnout na zaøízení nezávislou
vrstvu pro øeèovou syntézu.  Mìl by poskytovat jednoduché rozhraní pro
klientské aplikace (aplikace, které chtìjí mluvit), stejnì jako pro
ovladaèe konkrétních zaøízení (rùzné øeèové syntetizéry).

   Vysoce kvalitní øeèová syntéza je tu ji¾ dlouho a nyní je pou¾itelná
i pro bì¾né u¾ivatele na jejich domácích poèítaèích.  Obèas to pøichází
jako nutnost, obèas je to jen dobrá vlastnost, aby nìkteré programy
poskytovaly øeèový výstup.  Pro syntézu hlasu je tu ¹iroké pole vyu¾ití
od výukového software a¾ po specializované systémy, jako jsou napøíklad
nemocnice èi laboratoøe.  Pro zrakovì posti¾ené u¾ivatele je to jedna
ze dvou základních cest, jak získat výstup z poèítaèe (tou druhou je
Braillský øádek).

   Existují rùzné øeèové syntetizéry s rùznými schopnostmi.  Nìkteré z
nich jsou hardwarové, nìkteré softwarové.  Nìkteré jsou svobodným
software a jsou volnì dostupné na internetu.  Programátoøi to mají
opravdu tì¾ké, kdy¾ chtìjí své programy rozmluvit, proto¾e potøebují
nejprve najít nìjaký vhodný syntetizér (dlouhé hodiny experimentování a
tak dále) a potom jej potøebují nìjak zprovoznit s jejich programem.
Èasto musí psát pro tyto programy èi hardwarová zaøízení vlastní
ovladaèe a dìlají to znovu a znovu.  Snadno si lze pøedstavit, ¾e se to
celé zhroutí kdy¾ nevinný u¾ivatel spustí dva programy najednou. Kdyby
pøesto nastartovaly oba, budou køièet jeden pøes druhého.

   Tím je pro programátory velmi obtí¾né implementovat do svých
programù podporu øeèové syntézy (pro nevidomé u¾ivatele, nebo prostì
pro lep¹í u¾ivatelské rozhraní) a je to jeden z dùvodù, proè poøád
je¹tì plnì nevyu¾íváme toho, co øeèová syntéza nabízí.

   V ideálním svìtì by programátoøi mohli pro øeèovou syntézu pou¾ívat
podobné pøíkazy, jako to dìlají pro textový výstup na obrazovku
(printf, puts, ...).  V ideálním svìtì by existovalo nìjaké
speech_printf(), které by se staralo o to, aby byla zpráva pøemluvena
ve správný èas bez pøeru¹ování ostatních.  Programátor by se tak
nemusel starat o to, jak je pøesnì komunikace s øeèovým syntetizérem
implementována.  V ideálním svìtì by byl v ka¾dé GNU/Linuxové
distribuci nìjaký øeèový syntetizér a nìjaké rozhraní starající se o
aplikace, které chtìjí mluvit, dovolující u¾ivatelùm nastavit si
parametry øeèi a poskytující nìjaké jednoduché rozhraní (jako
speech_printf()) pomocí nìjaké sdílené knihovny pro programátory.  Bude
to jì¹tì dlouhá cesta ne¾ se nám podaøí dosáhnout tohoto stavu vìcí,
ale se Speech Dispatcherem dìláme první krùèky...

1.2 Základní design
===================

V komunikaci mezi v¹emi rùznými aplikacemi a syntetizéry je obrovský
nepoøádek.  Proto jsme chtìli, aby byl Speech Dispatcher vrstva
oddìlující aplikace a syntetizéry tak, aby se aplikace nemusely starat
o syntetizéry a syntetizéry se nemusely starat o interakci s aplikacemi.

   Rozhodli jsme se implementovat Speech Dispatcher jako server, který
pøijímá od aplikací pøíkazy pøes protokol nazvaný `SSIP', zpracovává je
a, pokud je to nutné, zavolá pøíslu¹nou funkci daného výstupního
modulu, který pak komunikuje s nìkterým z rùzných syntetizátorù.

   Ka¾dý klient (aplikace, která chce mluvit) otevøe socketové spojení
na Speech Dispatcher a volá funkce jako say(), stop(), pause()
poskytované knihovnou implementující tento protokol.  Tato sdílená
knihovna je stále na stranì klienta a posílá Speech Dispatcheru SSIP
pøíkazy pøes otevøený socket.  Kdy¾ pøíkazy dorazí do Dispatchera, ten
je zpracuje, pøeète text, který by mìl být pøeøíkán a vlo¾í jej do
fronty podle jeho priority.  Potom se rozhodne kdy, s jakými parametry
(nastavovanými klientským programem i u¾ivatelem) a na jakém
syntetizéru zprávu nechá pøemluvit.  Tyto po¾adavky na mluvení jsou pak
zpracovávány výstupními moduly (pluginy) pro rùzné hardwarové a
softwarové syntetizéry a pøeøíkány nahlas.

   Detailní popis programování klientù i serveru je k dispozici v
anglickém manuálu.

1.3 Pøehled základních rysù
===========================

Speech Dispatcher z pohledu u¾ivatele:

   * snadná konfigurace rùzných mluvících aplikací, centrální správa

   * mo¾nost volnì rozhodovat, jaká aplikace bude mluvit s jakým
     syntetizérem

   * ménì èasu vìnovaného konfiguraci a ladìní rùzných aplikací
     vyu¾ívajících syntézu

   * historie zpráv pro zrakovì posti¾ené u¾ivatele

   Speech Dispatcher z pohledu programátora aplikace:

   * snadná cesta, jak aplikaci rozmluvit

   * jednotné rozhraní k rùzným syntetizérùm

   * synchronizace zpráv na vy¹¹í úrovni (kategorizace pomocí priorit)

   * mo¾nost nemuset se starat o konfiguraci parametrù hlasu

1.4 Souèasný stav
=================

TODO:

2 U¾ivatelská dokumentace
*************************

2.1 Základní funkce
===================

V této sekci je detailnìj¹í popis základních funkcí Speech Dispatcheru.

2.1.1 Model priorit zpráv
-------------------------

Speech Dispatcher nemù¾e syntetizovat v¹echny zprávy, které do nìj
pøichází z prostého dùvodu, ¾e zprávy pøicházejí obyèejnì rychleji, ne¾
je syntetický hlas doká¾e èíst.  Na obrazovce monitoru je v porovnání s
jednokanálovým øeèovým výstupem relativnì hodnì místa.  Z toho dùvodu
pou¾íváme systém nìkolika priorit zamìøených na rùzné typy zpráv.

   My¹lenka je taková, ¾e úlohou programátora klientské aplikace bude
pouze urèit pro ka¾dou zprávu urèitou prioritu odpovídající typu dané
zprávy.  Ve¹kerá synchronizace a pøepínání mezi tìmito zprávami (které
mohou pocházet od rùzných klientù) potom bude zaji¹tìno aplikováním
urèitých pravidel ve Speech Dispatcheru.

2.1.1.1 Priority Categories
...........................

Speech Dispatcher poskytuje systém pìti priorit.  Ka¾dá zpráva obsahuje
buï explicitní informaci o prioritì, nebo jí je pøiøazena výchozí
priorita.

   Prosím podívejte se také na pøilo¾ený diagram (dole).

Priorita `important'
....................

Tato zpráva bude pøeøíkána okam¾itì, jak dorazí do serveru.  Není nikdy
pøeru¹ena.  Kdy¾ server obdr¾í souèasnì nìkolik rùzných zpráv této
priority, ty jsou ulo¾eny a pøeøíkány v poøadí, ve kterém pøi¹ly.

   Kdy¾ pøijde nová zpráva priority `important' a zrovna se øíká nìjaká
jiná zpráva, tato jiná zpráva je zahozena.  Dal¹í zprávy ni¾¹ích
priorit jsou buï pozdr¾eny (priorita `message' a `text') ne¾ ji¾
neèekají na pøeøíkání ¾ádné zprávy priority `important', nebo jsou
zahozeny (priority `notification' a `progress').

   Tyto zprávy by mìly být tak krátké, jak je to jen mo¾né, a mìly by
být pou¾ívány pouze zøídka, proto¾e blokují výstup v¹ech ostatních
zpráv.

Priorita `message'
..................

Tato zpráva bude pøeøíkána, pokud ji¾ ve frontì neèeká ¾ádná jiná zpráva
priority `important' nebo `message'.  V opaèném pøípadì je tato zpráva
pozdr¾ena dokud nebudou v¹echny pøeøíkány.  To znamená, ¾e priorita
`message' nezastavuje sama sebe.  Kdy¾ ve frontì èekají zprávy priorit
`notification' nebo `progress' nebo `text' kdy¾ pøijde zpráva priority
`message', jsou zahozeny.

Priorita `text'
...............

Tato zpráva bude pøeøíkána, kdy¾ ve frontì neèeká ¾ádná zpráva priority
`important' nebo `message'.  Pokud èeká, tato nová zpráva je pozdr¾ena
dokud nebudou pøedchozí zprávy pøeøíkány.

   Priorita text pøerqu¹uje sama sebe.  To znamená, ¾e kdy¾ pøijde
nìkolik zpráv priority text, ty nejsou pøeøíkány v poøadí, ve kterém
pøi¹ly, ale bude vyøèena pouze poslední z nich a ostatní jsou pøeru¹eny
a zahozeny.

   Pokud jsou ve frontì zprávy priorit `notification' nebo `progress'
nebo se právì pøeøíkávají, jsou zahozeny.

Priorita `notification'
.......................

Toto je zpráva nízké priority.  Pokud ve frontì èekají zprávy priorit
`important', `messages', `text' nebo `progress' nebo jsou právì
pøeøíkávány, tato nová zpráva priority `notification' je zru¹ena.

   Tato priorita pøeru¹uje sama sebe, tak¾e kdy¾ pøijde najednou více
zpráv s prioritou `notification', pøeøíká se pouze poslední z nich.

Priority `progress'
...................

Toto je speciální priorita pro zprávy, které pøicházejí krátce po sobì
a nesou informaci o nìjaké probíhající èinnosti (napø. `Dokonèeno 45%').

   Kdyby nové zprávy pøeru¹ovaly ostatní (viz. priorita Notification),
u¾ivatel by nemusel sly¹et ani jednu zprávu do konce.

   Tato priorita se chová stejnì jako `notification' s výjimkou dvou
vìcí.

   * Zprávy této priority nepøeru¹ují jedna druhou.  Místo toho, pokud
     je zrovna pøeøíkávána jiná zpráva této priority, novì pøíchozí
     zpráva je zahozena.

   * Speech Dispatcher se sna¾í detekovat poslední zprávu v sérii
     pøíchozích zpráv a zaruèit její pøeøíkání (pro u¾ivatele je
     dùle¾ité sly¹et zprávu `Completed 100%', aby vìdìl, ¾e proces ji¾
     skonèil).  V¾dy, kdy¾ ve frontì ji¾ neèeká ¾ádná nová zpráva této
     priority a poslední pøíchozí zpráva je¹tì nebyla pøeøíkána, je
     její pøeøíkání vynuceno s prioritou `message'.

2.1.1.2 Diagram priorit
.......................

2.1.1.3 Pøíklady vyu¾ití priorit
................................

Pøíklady pou¾ití priority `important' jsou:

   * chybové hlá¹ky

   * velmi dùle¾ité zprávy

   * ...

   Pøíklady pou¾ití priority `message' jsou:

   * bì¾né zprávy programu

   * varování

   * ...

   Pøíklady pou¾ití priority `text' jsou:

   * text, na kterém u¾ivatel pracuje

   * pøedèítaný text

   * polo¾ky menu

   * ...

   Pøíklady pou¾ití priority `notification' jsou:

   * ménì dùle¾ité informace

   * písmenka pøi vkládání

   * run-time nápovìda

   * ...

   Pøíklady pou¾ití priority `progress' jsou:

   * "dokonèeno 15%", "dokonèeno 16%", "dokonèeno 17%"

   * "Naèítám zvuky", "Naèítám grafiku", "Naèítám ai", ...

2.1.2 Historie zpráv
--------------------

Pro nevidomé a zrakovì posti¾ené je dobrou vlastností, pokud mají
mo¾nost nìjakým jednoduchým klientem procházet historii vyslovených
zpráv.

   Nìkteré ménì dùle¾ité zprávy jsou pøijmuty Speech Dispatcherem bez
toho, aby byly pøeøíkány, proto¾e jsou potlaèeny dùle¾itìj¹ími
informacemi.  To je nedìlitelná vlastnost ka¾dého øeèového rozhraní,
proto¾e není mo¾né podat v øeèovém výstupu tolik informací, kolik se
jich vejde na obrazovku.  To je jeden z hlavních dùvodù, proè je
výhodné udr¾ovat historii pøijatých zpráv, aby se mohl u¾ivatel
podívat, zda mu neu¹lo nìco dùle¾itého.

2.1.2.1 Access Rights
.....................

Aby bylo ochránìno soukromí u¾ivatelù, Speech Dispatcher omezuje
pøístup k historii na urèitou podmno¾inu pøijatých zpráv.  Platí
následující pravidla:

   * V¹echny zprávy pøijaté od urèitého klientského spojení jsou tomuto
     spojení pøístupny i v historii.

   * V¹echny zprávy odeslané urèitým u¾ivatelem jsou tomuto u¾ivateli
     pøístupny i v historii.

   * V¹echny zprávy zaslané u¾ivatelem `speechd' jsou pøístupny v¹em
     u¾ivatelùm na daném systému, pod kterým bì¾í Speech Dispatcher ve
     skupinì `speechd'.

   * ®ádné dal¹í zprávy nejsou pøístupné.

   Dvì zprávy jsou pova¾ovány za identické jestli¾e jejich spojení
pocházejí z toho samého poèítaèe, u¾ivatelská jména jsou stejná a
jejich identita mù¾e být ovìøena, jak je popsáno v Autentifikace u¾ivatelù.
Pokud nemù¾e být u¾ivatelova identita ovìøena, tento
u¾ivatel je pova¾ován za jiného ne¾ v¹ichni pøipojení nebo døíve
pøipojení u¾ivatelé.

2.1.3 Více výstupních modulù
----------------------------

Speech Dispatcher podporuje soubì¾né pou¾ívání více výstupních modulù.
Pokud tyto moduly poskytují dobrou synchronizaci, lze je pøi ètení
zpráv kombinovat.  Pokud napø. modul1 mluví anglicky a èesky, zatímco
modul2 mluví pouze nìmecky, tak pokud pøijde nìjaká zpráva v nìmèinì,
pou¾ije se modul2, zatímco pro ostatní jazyky se pou¾ije modul1.  Na
druhé stranì jazyk není jediným kritériem pro takové rozhodnutí.
Pøesná pravidla pro výbìr výstupího modulu mohou být ovlivnìna v
konfiguraèním souboru `speechd.conf'.

2.1.4 Autentifikace u¾ivatelù
-----------------------------

NOTE: Na implementaci této vlastnosti se pracuje, ale souèasná verze ji
nepodporuje.

   Speech Dispatcher neposkytuje ¾ádný explicitní autentifikaèní
mechanismus.  K ovìøení identity u¾ivatlù pou¾íváme Identification
Protocol definovaný v RFC 1413.

   V konfiguraci je mo¾né specifikovat mapování u¾ivatelù. To umo¾òuje
jednat s urèitými u¾ivateli jako s jedním a pøidìlit jim stejná práva
(napø. procházet jejich Historie zpráv).

2.2 Invoking
============

2.2.1 Potøebná privilegia
-------------------------

Speech Dispatcher mù¾e být obecnì spou¹tìn pod obyèejným u¾ivatelem.
Sna¾ili jsme se jej zabezpeèit, jak jen to bylo mo¾né, ale nejsme
odborníky na poèítaèovou bezpeènost a kód mù¾e obsahovat nebezpeèné
chyby.  Nedoporuèujeme jej spou¹tìt jako root nebo pod jiným vysoce
privilegovaným u¾ivatelem.

   Jediná omezení jsou tyto:

   * Speech Dispatcher vytváøí PID file standardnì ve
     `/var/run/speech-dispatcher.pid', tak¾e `/var/run/' musí být danému
     u¾ivateli pøístupné k zápisu.  To mù¾e být zmìnìno nastavením volby
     `pidpath' pøi volání skriptu `./configure' pøi kompilaci.

   * Kdy¾ je zapnuto logování, výchozí cesta, kam Speech Dispatcher
     zapisuje svùj log, je `/var/log/speech-dispatcher.log'.  To ale
     mù¾e být kdykoliv pøenastaveno v hlavním konfiguraèním souboru.

2.2.2 Volby pøíkazové øádky
---------------------------

Speech Dispatcher mù¾e být spu¹tìn s tìmito volbami:

   `speech-dispatcher [-{d|s}] [-l {1|2|3|4|5}] [-p=port] | [-v] | [-h]'

`-d or --run-daemon'
     Spustí program jako démona (bì¾í v pozadí, odpojí se od terminálu,
     atd.)  Toto je výchozí chování.

`-s or --run-single'
     Spustí program jako bì¾nou aplikaci bì¾ící na popøedí.

`-l level or --log-level=level'
     Vybere po¾adovaný logovací úroveò. Logovací úroveò je èíslo mezi 0
     a 5 (0 znamená neloguj nic, 5 znamená zapisuj témìø v¹e vèetnì
     zpracovávaného textu.)  Standardní je 3. See Úrovnì logování.

     Logovací úroveò 5 by nemìla být pou¾ívána k jiným úèelùm, ne¾ pro
     hledání chyb a to pouze krátkodobì.  Logy, které produkuje mohou
     narùst do obrovské velikosti a obsahují text ètený u¾ivateli
     nezávisle na rùzných pøístupových právech, jak platí pro historii.
     Spou¹tìt server s touto úrovní logování tedy mù¾e snadno vést k
     naru¹ení soukromí.

`-p or --port'
     Zadá port, na kterém by mìl server èekat na klienty.  Výchozí je
     6560.

`-v or --version'
     Vypí¹e informace o verzi Speech Dispatchera.  Také oznámí základní
     informace o copyrightu.

`-h or --help'
     Vypí¹e nápovìdu o volbách pøíkazové øádky, upozornìní o copyrightu
     a emailovou adresu pro zasílání oznámení o chybách.

2.3 konfigurace
===============

Speech Dispatcher mù¾e být konfigurován na nìkolika rùzných úrovních.
Jedna z nich je nastavování globálních parametrù pøes serverový
konfiguraèní soubor.  Je zde i podpora pro konfiguraci specifickou pro
urèité klienty.

   Nìkteré aplikace mají vlastní mechanismus nastavování voleb
souvisejících s øeèovou syntézou.  Pro detaily o tìchto nastaveních se
prosím podívejte do dokumentace daného programu.

   Následující kapitoly se zabývají pouze konfigurací na stranì serveru
pøes konfiguraèní soubor.

2.3.1 Syntaxe konfiguraèního souboru
------------------------------------

Pro naèítání configurace zalo¾ené na textových souborech pou¾íváme
knihovnu DotConf, tak¾e bude syntaxe nejspí¹ mnoha u¾ivatelùm povìdomá.

   Ka¾dá z øetìzcových konstant, pokud není uvedeno jinak, by mìla být
zakódována v UTF-8.  Jména voleb nepou¾ívají jiné znaky ne¾ standardní
ASCII sadu omezenou na znaky (`a', `b', ...), pomlèky (`-') a
podtr¾ítka `_'.

   Komentáøe a doèasnì neaktivní volby zaèínají znakem `#'.  Pokud
chcete takovu volbu zapnout, staèí smazat znak komentáøe a nastavit
volbu na po¾adovanou hodnotu.
     # toto je komentar
     # InactiveOption "tato volba je zatim vypla komentarem"

   Øetìzce jsou uzavøeny v uvozovkách.
     LogFile  "/var/log/speech-dispatcher.log"

   Èísla jsou zapsána bez uvozovek.
     Port 6560

   Pøepínaèe pou¾ívají On (zapnuto) a Off (vypnuto).
     Debug Off

2.3.2 Configuration options
---------------------------

V¹echny dostupné volby jsou zdokumentovány pøímo v konfiguraèním
souboru a jsou k nim uvedeny i pøíklady. Vìt¹ina voleb je nastavena na
výchozí hodnotu a zakomentována.  Pokud je chcete zmìnit, postaèí
modifikovat jejich hodnotu a smazat symbol komentáøe `#'.

2.3.3 Output Modules Configuration
----------------------------------

Ka¾dý u¾ivatel by si mìl zapnout ve své konfiguraci alespoò jeden
výstupní modul, pokud chce, aby Speech Dispatcher produkoval nìjaký
zvukový výstup.  Kdy¾ není naèten ¾ádný výstupní modul, Speech
Dispatcher sice nastartuje, bude komunikovat s klienty a logovat zprávy
do historie, ale nebude produkovat ¾ádný zvuk.

   Ka¾dý výstupní modul je tøeba do Speech Dispatchera natáhnout jednou
øádkou "AddModule" v `etc/speechd.conf'.  Navíc, ka¾dý výstupní modul má
pøiøazen vlastní konfiguraèní soubor.

2.3.3.1 Natahování modulù ve speechd.conf
.........................................

Ka¾dý modul, který by se mìl spustit pøi startu Speech Dispatchera,
musí být nata¾en pøíkazem `AddModule' v konfiguraci.  V¹imnìte si, ¾e
lze natáhnout jeden binární modul vícekrát s rùznými konfiguraèními
soubory a pod jinými jmény.  To je u¾iteèné hlavnì pro natahování
generických výstupních modulù.  See Konfigurace generického výstupního modulu.

     AddModule "MODULE_NAME" "MODULE_BINARY" "MODULE_CONFIG"

   MODULE_NAME je jméno daného výstupního modulu.

   MODULE_BINARY je jméno binárního spustitelného souboru tohoto
výstupního modulu.  To mù¾e být buï cesta absolutní nebo relativní k
`bin/speechd-modules/'.

   MODULE_CONFIG je soubor s konfigurací pro tento konkrétní výstupní
modul.  Cesta mù¾e být absolutní i relativní k
`etc/speech-dispatcher/modules/'.  Tento parametr je volitelný (není
tøeba jej uvádìt).

2.3.3.2 Konfiguraèní soubory výstupních modulù
..............................................

Ka¾dý výstupní modul je odli¹ný a proto má odli¹né volby v konfiguraci.
Prosím prostudujte si komentáøe v daném konfiguraèním souboru.  Zde je
popsáno pouze nìkolik voleb, které jsou pro nìkteré výstupní moduly
spoleèné.

`AddVoice "LANGUAGE" "SYMBOLICNAME" "NAME"'
     Ka¾dý výstupní modul poskytuje nìjaké hlasy a nìkdy dokonce
     podporuje rùzné jazyky.  Z toho dùvodu byl zaveden spoleèný
     mechanismus, kterým mù¾ou být tyto hlasy definovány v konfiguraci.
     ®ádný modul ov¹em není povinen tuto volbu pou¾ívat.  Nìkteré
     syntetizátory, napø. Festival, podporují symbolická jména SSIP
     pøímo, tak¾e konfigurace konkrétních hlasù se provádí v
     syntetizátoru samotném.

     Ka¾dému definovanému hlasu odpovídá pøesnì jedna øádka `AddVoice'.

     LANGUAGE je ISO kód jazyka tohoto hlasu (en, cs, de, ...)

     SYMBOLICNAME je symbolické jméno, pod kterým chcete, aby byl tento
     hlas dostupný.  See Standardní hlasy, pro seznam symbolických
     jmen, která mù¾ete pou¾ít.

     NAME je jméno specifické pro daný výstupní modul.  Prosím
     podívejte se na komentáøe v pøíslu¹ném konfiguraèním souboru v
     sekci AddModule pro detailnìj¹í informace.

     Napø. definice, kterou v souèastnosti pou¾íváme pro Epos (generic)
     vypadá takto:

                  AddVoice        "cs"  "male1"   "kadlec"
                  AddVoice        "sk"  "male1"   "bob"

`ModuleDelimiters "DELIMITERS", ModuleMaxChunkLength LENGTH'
     Èasto se výstupní modul nesna¾í vysyntetizovat celý pøíchozí text
     najednou, ale místo toho jej nejprve rozøe¾e na men¹í kousky
     (vìty, èásti vìt) a ty potom postupnì odesílá na syntézu.  Tento
     pøístup, vyu¾ívaný nìkterými výstupními moduly, je mnohem
     rychlej¹í, ale na druhé stranì zase limituje schopnost syntetizéru
     poskytnout dobrou intonaci.

     Z toho dùvodu máte obyèejnì mo¾nost zkonfigurovat si na jakých
     znacích (DELIMITERS) by se mìl text rozdìlit na men¹í èásti (pokud
     jsou následovány nìjakým whitespace znakem).  Druhá volba (LENGTH)
     udává, po kolika znacích by se mìl text násilnì rozdìlit, pokud
     nebyl nalezen ¾ádný delimiter.

     Pokud tato dvì pravidla zpøísníte, dostanete lep¹í rychlost, ale
     vzdáte se urèité èásti kvality intonace.  Tak¾e napøíklad pro
     pomalej¹í poèítaèe doporuèujeme do DELIMITERS vlo¾it i èárku (,),
     aby byl text rozdìlen i na èástech vìty, zatímco na rychlej¹ích
     poèítaèích je lep¹í tam èárku nedávat, tak¾e do syntetizéru v¾dy
     dorazí celá souvìtí.

     To samé platí o `MaxChunkLength'. Pro rychlej¹í poèítaèe je lep¹í
     nastavit vìt¹í hodnotu.

     Napøíklad výchozí hodnoty ve výstupním modulu pro Festival jsou:

              FestivalMaxChunkLength  300
              FestivalDelimiters  ".?!;,:"

     Výstupní modul se mù¾e také rozhodnout dìlit vìty na delimiters
     pouze pokud ty jsou následovány mezerou.  Tak¾e napøíklad
     "file123.tmp" by rozdìleno nebylo, ale vìta "The horse raced
     around the fence, that was lately painted green, fell."  by
     rozdìlena byla (to je mimochodem velmi zajímavá vìta).

2.3.3.3 Konfigurace generického výstupního modulu
.................................................

Generický výstupní modul u¾ivatelùm dovoluje jednodu¹e si napsat vlastní
jednoduchý výstupní modul pro syntetizéry, které mají rozhraní ve formì
jednoduchého øádkového klienta, pouze modifikací konfiguraèního
souboru.  Tímto zpùsobem nemusí psát ¾ádný specifický kód v C a
u¾ivatelé si mohou pøidávat podporu pro výstupní zaøízení i kdy¾ neumí
programovat.  See AddModule.

   Klíèová èást ka¾dého generického výstupního modulu je definice
øetìzce, který se má spou¹tìt.

 -- Konfigurace generického modulu: GenericExecuteSynth
          "EXECUTION_STRING"
     `execution_string' je pøíkaz, který by mìl být zavolán v shellu,
     kdy¾ je potøeba nìco øíct.  Ve skuteènosti to mù¾e být více jak
     jeden pøíkaz, dohromady zøetìzené operátorem `&&'.  Kdy¾ bude
     výstupní modul chtít pøeøíkávání zprávy zastavit, za¹le tìmto
     procesùm signál KILL, tak¾e je dùle¾ité, aby pou¾ité pøíkazy po
     obdr¾ení KILL okam¾itì pøestaly mluvit. (Na vìt¹inì GNU/Linuxových
     systémù má tuto vlastnost utilita `play')

     V `execution_string' mù¾ete vyu¾ít tìchto promìnných, které budou
     nahrazeny poøadovanými hodnotami, ne¾ bude pøíkaz vykonán.

        * `$DATA' Text, který by mìl být pøeøíkán.  Znaky øetìzce,
          které by nìjak interferovali se zpracováním v bashi budou
          automaticky nahrazeny odpovídajícími escape sekvencemi.  Asi
          bude ale nutné uvést kolem této promìnné uvozovky (napø.
          takto: `\"$DATA\"').

        * `$LANG' Identifikaèní øetìzec jazyka (ten je definován pomocí
          GenericLanguage).

        * `$VOICE' Identifikaèní øetìzec hlasu (ten je definován pomocí
          AddVoice).

        * `$PITCH' Po¾adovaná vý¹ka hlasu (desetinné èíslo definované v
          GenericPitchAdd a v GenericPitchMultiply)

        * `$RATE' Po¾adovaná rychlost hlasu (desetinné èíslo definované
          v GenericRateAdd a v GenericRateMultiply)

     Tady je pøíklad z `etc/speech-dispatcher/modules/epos-generic.conf'
          GenericExecuteSynth \
          "epos-say -o --language $LANG --voice $VOICE --init_f $PITCH --init_t $RATE \
          \"$DATA\" | sed -e s+unknown.*$++ >/tmp/epos-said.wav && play /tmp/epos-said.wav >/dev/null"

 -- Konfigurace generického modulu: AddVoice "LANGUAGE" "SYMBOLICNAME"
          "NAME"
     AddVoice.

 -- Konfigurace generického modulu: GenericLanguage "iso-code"
          "string-subst"
     Definuje, jaký øetìzec `string-subst' by mìl být nahrazen za
     `$LANG' pro daný `iso-code' ISO kód jazyka.

     Opìt pøíklad z Epos generic:
          GenericLanguage "en" "english"
          GenericLanguage "cs" "czech"
          GenericLanguage "sk" "slovak"

 -- Konfigurace generického modulu: GenericRateAdd NUM

 -- Konfigurace generického modulu: GenericRateMultiply NUM

 -- Konfigurace generického modulu: GenericPitchAdd NUM

 -- Konfigurace generického modulu: GenericPitchMultiply NUM
     Tyto parametry nastavují konverzi pro výpoèet rychlosti a vý¹ky.
     (`$RATE' a `$PITCH').

     Výsledná rychlost (nebo vý¹ka) je dána následujícím vzorcem:
             (speechd_rate * GenericRateMultiply) + GenericRateAdd
     kde speechd_rate je hodnota mezi -100 (nejni¾¹í) a +100
     (nejvy¹¹í).  Je tøeba definovat nìjakou rozumnou konverzi pro daný
     syntetizér.

     (Hodnoty v GenericNìcoMultiply jsou vynásobeny stem, proto¾e
     stávající verze DotConfu nepodporuje desetinná èísla.  Mù¾ete tedy
     psát 0.85 jako 85 atd.)

2.3.4 Úrovnì logování
---------------------

Ve Speech Dispatcheru je 6 rùzných úrovní logování.  0 znamená ¾ádné
logování, zatímco 5 znamená vypisovat témìø v¹echny dostupné informace.

   * Úroveò 0
        * ®ádné informace

   * Úroveò 1
        * Informace o startu a vypínání.

   * Úroveò 2
        * Informace o chybách, které nastaly.

        * Alokace a uvolòování zdrojù pøi startu a pøi exitu.

   * Úroveò 3
        * Informace o pøijímání/odepírání/zavírání klientských spojení.

        * Informace o neplatných SSIP pøíkazech od klientù.

   * Úroveò 4
        * Je vypisován ka¾dý pøijatý pøíkaz

        * Informace o zpracovávání vstupu

        * Informace o ukládání zpráv do front

        * Informace o fungování historie, zvukových ikon, atd.
          facilities.

        * Informace o práci vlákna speak()

   * Úroveò 5 (Ta slou¾í pouze pro ladící úèely a mù¾e vypisovat
     opravdu *mnoho* dat. Pou¾ívejte opatrnì.)
        * V¹echna obdr¾ená data jsou vypisována (zprávy od klientù)

        * Ladící informace.

Appendix A Standardní hlasy
***************************

`MALE1'

`MALE2'

`MALE3'

`FEMALE1'

`FEMALE2'

`FEMALE3'

`CHILD_MALE'

`CHILD_FEMALE'

   Skuteèná dostupnost tìchto hlasù není zaruèena, ale pøíkaz `SET SELF
VOICE' musí akceptovat jakýkoliv z nich.  Pokud není daný hlas
dostupný, je mapován na jiný hlas výstupním modulem.

Appendix B GNU General Public License
*************************************

                         Version 2, June 1991
     Copyright (C) 1989, 1991 Free Software Foundation, Inc.
     51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

Preamble
========

The licenses for most software are designed to take away your freedom
to share and change it.  By contrast, the GNU General Public License is
intended to guarantee your freedom to share and change free
software--to make sure the software is free for all its users.  This
General Public License applies to most of the Free Software
Foundation's software and to any other program whose authors commit to
using it.  (Some other Free Software Foundation software is covered by
the GNU Library General Public License instead.)  You can apply it to
your programs, too.

   When we speak of free software, we are referring to freedom, not
price.  Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
this service if you wish), that you receive source code or can get it
if you want it, that you can change the software or use pieces of it in
new free programs; and that you know you can do these things.

   To protect your rights, we need to make restrictions that forbid
anyone to deny you these rights or to ask you to surrender the rights.
These restrictions translate to certain responsibilities for you if you
distribute copies of the software, or if you modify it.

   For example, if you distribute copies of such a program, whether
gratis or for a fee, you must give the recipients all the rights that
you have.  You must make sure that they, too, receive or can get the
source code.  And you must show them these terms so they know their
rights.

   We protect your rights with two steps: (1) copyright the software,
and (2) offer you this license which gives you legal permission to copy,
distribute and/or modify the software.

   Also, for each author's protection and ours, we want to make certain
that everyone understands that there is no warranty for this free
software.  If the software is modified by someone else and passed on, we
want its recipients to know that what they have is not the original, so
that any problems introduced by others will not reflect on the original
authors' reputations.

   Finally, any free program is threatened constantly by software
patents.  We wish to avoid the danger that redistributors of a free
program will individually obtain patent licenses, in effect making the
program proprietary.  To prevent this, we have made it clear that any
patent must be licensed for everyone's free use or not licensed at all.

   The precise terms and conditions for copying, distribution and
modification follow.

    TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
  0. This License applies to any program or other work which contains a
     notice placed by the copyright holder saying it may be distributed
     under the terms of this General Public License.  The "Program,"
     below, refers to any such program or work, and a "work based on
     the Program" means either the Program or any derivative work under
     copyright law: that is to say, a work containing the Program or a
     portion of it, either verbatim or with modifications and/or
     translated into another language.  (Hereinafter, translation is
     included without limitation in the term "modification.")  Each
     licensee is addressed as "you."

     Activities other than copying, distribution and modification are
     not covered by this License; they are outside its scope.  The act
     of running the Program is not restricted, and the output from the
     Program is covered only if its contents constitute a work based on
     the Program (independent of having been made by running the
     Program).  Whether that is true depends on what the Program does.

  1. You may copy and distribute verbatim copies of the Program's
     source code as you receive it, in any medium, provided that you
     conspicuously and appropriately publish on each copy an appropriate
     copyright notice and disclaimer of warranty; keep intact all the
     notices that refer to this License and to the absence of any
     warranty; and give any other recipients of the Program a copy of
     this License along with the Program.

     You may charge a fee for the physical act of transferring a copy,
     and you may at your option offer warranty protection in exchange
     for a fee.

  2. You may modify your copy or copies of the Program or any portion
     of it, thus forming a work based on the Program, and copy and
     distribute such modifications or work under the terms of Section 1
     above, provided that you also meet all of these conditions:

       a. You must cause the modified files to carry prominent notices
          stating that you changed the files and the date of any change.

       b. You must cause any work that you distribute or publish, that
          in whole or in part contains or is derived from the Program
          or any part thereof, to be licensed as a whole at no charge
          to all third parties under the terms of this License.

       c. If the modified program normally reads commands interactively
          when run, you must cause it, when started running for such
          interactive use in the most ordinary way, to print or display
          an announcement including an appropriate copyright notice and
          a notice that there is no warranty (or else, saying that you
          provide a warranty) and that users may redistribute the
          program under these conditions, and telling the user how to
          view a copy of this License.  (Exception: if the Program
          itself is interactive but does not normally print such an
          announcement, your work based on the Program is not required
          to print an announcement.)

     These requirements apply to the modified work as a whole.  If
     identifiable sections of that work are not derived from the
     Program, and can be reasonably considered independent and separate
     works in themselves, then this License, and its terms, do not
     apply to those sections when you distribute them as separate
     works.  But when you distribute the same sections as part of a
     whole which is a work based on the Program, the distribution of
     the whole must be on the terms of this License, whose permissions
     for other licensees extend to the entire whole, and thus to each
     and every part regardless of who wrote it.

     Thus, it is not the intent of this section to claim rights or
     contest your rights to work written entirely by you; rather, the
     intent is to exercise the right to control the distribution of
     derivative or collective works based on the Program.

     In addition, mere aggregation of another work not based on the
     Program with the Program (or with a work based on the Program) on
     a volume of a storage or distribution medium does not bring the
     other work under the scope of this License.

  3. You may copy and distribute the Program (or a work based on it,
     under Section 2) in object code or executable form under the terms
     of Sections 1 and 2 above provided that you also do one of the
     following:

       a. Accompany it with the complete corresponding machine-readable
          source code, which must be distributed under the terms of
          Sections 1 and 2 above on a medium customarily used for
          software interchange; or,

       b. Accompany it with a written offer, valid for at least three
          years, to give any third party, for a charge no more than your
          cost of physically performing source distribution, a complete
          machine-readable copy of the corresponding source code, to be
          distributed under the terms of Sections 1 and 2 above on a
          medium customarily used for software interchange; or,

       c. Accompany it with the information you received as to the offer
          to distribute corresponding source code.  (This alternative is
          allowed only for noncommercial distribution and only if you
          received the program in object code or executable form with
          such an offer, in accord with Subsection b above.)

     The source code for a work means the preferred form of the work for
     making modifications to it.  For an executable work, complete
     source code means all the source code for all modules it contains,
     plus any associated interface definition files, plus the scripts
     used to control compilation and installation of the executable.
     However, as a special exception, the source code distributed need
     not include anything that is normally distributed (in either
     source or binary form) with the major components (compiler,
     kernel, and so on) of the operating system on which the executable
     runs, unless that component itself accompanies the executable.

     If distribution of executable or object code is made by offering
     access to copy from a designated place, then offering equivalent
     access to copy the source code from the same place counts as
     distribution of the source code, even though third parties are not
     compelled to copy the source along with the object code.

  4. You may not copy, modify, sublicense, or distribute the Program
     except as expressly provided under this License.  Any attempt
     otherwise to copy, modify, sublicense or distribute the Program is
     void, and will automatically terminate your rights under this
     License.  However, parties who have received copies, or rights,
     from you under this License will not have their licenses
     terminated so long as such parties remain in full compliance.

  5. You are not required to accept this License, since you have not
     signed it.  However, nothing else grants you permission to modify
     or distribute the Program or its derivative works.  These actions
     are prohibited by law if you do not accept this License.
     Therefore, by modifying or distributing the Program (or any work
     based on the Program), you indicate your acceptance of this
     License to do so, and all its terms and conditions for copying,
     distributing or modifying the Program or works based on it.

  6. Each time you redistribute the Program (or any work based on the
     Program), the recipient automatically receives a license from the
     original licensor to copy, distribute or modify the Program
     subject to these terms and conditions.  You may not impose any
     further restrictions on the recipients' exercise of the rights
     granted herein.  You are not responsible for enforcing compliance
     by third parties to this License.

  7. If, as a consequence of a court judgment or allegation of patent
     infringement or for any other reason (not limited to patent
     issues), conditions are imposed on you (whether by court order,
     agreement or otherwise) that contradict the conditions of this
     License, they do not excuse you from the conditions of this
     License.  If you cannot distribute so as to satisfy simultaneously
     your obligations under this License and any other pertinent
     obligations, then as a consequence you may not distribute the
     Program at all.  For example, if a patent license would not permit
     royalty-free redistribution of the Program by all those who
     receive copies directly or indirectly through you, then the only
     way you could satisfy both it and this License would be to refrain
     entirely from distribution of the Program.

     If any portion of this section is held invalid or unenforceable
     under any particular circumstance, the balance of the section is
     intended to apply and the section as a whole is intended to apply
     in other circumstances.

     It is not the purpose of this section to induce you to infringe any
     patents or other property right claims or to contest validity of
     any such claims; this section has the sole purpose of protecting
     the integrity of the free software distribution system, which is
     implemented by public license practices.  Many people have made
     generous contributions to the wide range of software distributed
     through that system in reliance on consistent application of that
     system; it is up to the author/donor to decide if he or she is
     willing to distribute software through any other system and a
     licensee cannot impose that choice.

     This section is intended to make thoroughly clear what is believed
     to be a consequence of the rest of this License.

  8. If the distribution and/or use of the Program is restricted in
     certain countries either by patents or by copyrighted interfaces,
     the original copyright holder who places the Program under this
     License may add an explicit geographical distribution limitation
     excluding those countries, so that distribution is permitted only
     in or among countries not thus excluded.  In such case, this
     License incorporates the limitation as if written in the body of
     this License.

  9. The Free Software Foundation may publish revised and/or new
     versions of the General Public License from time to time.  Such
     new versions will be similar in spirit to the present version, but
     may differ in detail to address new problems or concerns.

     Each version is given a distinguishing version number.  If the
     Program specifies a version number of this License which applies
     to it and "any later version," you have the option of following
     the terms and conditions either of that version or of any later
     version published by the Free Software Foundation.  If the Program
     does not specify a version number of this License, you may choose
     any version ever published by the Free Software Foundation.

 10. If you wish to incorporate parts of the Program into other free
     programs whose distribution conditions are different, write to the
     author to ask for permission.  For software which is copyrighted
     by the Free Software Foundation, write to the Free Software
     Foundation; we sometimes make exceptions for this.  Our decision
     will be guided by the two goals of preserving the free status of
     all derivatives of our free software and of promoting the sharing
     and reuse of software generally.

                                NO WARRANTY
 11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO
     WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE
     LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
     HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT
     WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT
     NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
     FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE
     QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
     PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY
     SERVICING, REPAIR OR CORRECTION.

 12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN
     WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY
     MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE
     LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL,
     INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR
     INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
     DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU
     OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY
     OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN
     ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

                      END OF TERMS AND CONDITIONS
How to Apply These Terms to Your New Programs
=============================================

If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these
terms.

   To do so, attach the following notices to the program.  It is safest
to attach them to the start of each source file to most effectively
convey the exclusion of warranty; and each file should have at least
the "copyright" line and a pointer to where the full notice is found.

     ONE LINE TO GIVE THE PROGRAM'S NAME AND AN IDEA OF WHAT IT DOES.
     Copyright (C) 19YY  NAME OF AUTHOR

     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.

     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.

     You should have received a copy of the GNU General Public License along
     with this program; if not, write to the Free Software Foundation, Inc.,
     51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

   Also add information on how to contact you by electronic and paper
mail.

   If the program is interactive, make it output a short notice like
this when it starts in an interactive mode:

     Gnomovision version 69, Copyright (C) 20YY NAME OF AUTHOR
     Gnomovision comes with ABSOLUTELY NO WARRANTY; for details
     type `show w'.  This is free software, and you are welcome
     to redistribute it under certain conditions; type `show c'
     for details.

   The hypothetical commands `show w' and `show c' should show the
appropriate parts of the General Public License.  Of course, the
commands you use may be called something other than `show w' and `show
c'; they could even be mouse-clicks or menu items--whatever suits your
program.

   You should also get your employer (if you work as a programmer) or
your school, if any, to sign a "copyright disclaimer" for the program,
if necessary.  Here is a sample; alter the names:

     Yoyodyne, Inc., hereby disclaims all copyright
     interest in the program `Gnomovision'
     (which makes passes at compilers) written
     by James Hacker.

     SIGNATURE OF TY COON, 1 April 1989
     Ty Coon, President of Vice

   This General Public License does not permit incorporating your
program into proprietary programs.  If your program is a subroutine
library, you may consider it more useful to permit linking proprietary
applications with the library.  If this is what you want to do, use the
GNU Library General Public License instead of this License.

Appendix C GNU Free Documentation License
*****************************************

                      Version 1.2, November 2002
     Copyright (C) 2000,2001,2002 Free Software Foundation, Inc.
     51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

  0. PREAMBLE

     The purpose of this License is to make a manual, textbook, or other
     functional and useful document "free" in the sense of freedom: to
     assure everyone the effective freedom to copy and redistribute it,
     with or without modifying it, either commercially or
     noncommercially.  Secondarily, this License preserves for the
     author and publisher a way to get credit for their work, while not
     being considered responsible for modifications made by others.

     This License is a kind of "copyleft", which means that derivative
     works of the document must themselves be free in the same sense.
     It complements the GNU General Public License, which is a copyleft
     license designed for free software.

     We have designed this License in order to use it for manuals for
     free software, because free software needs free documentation: a
     free program should come with manuals providing the same freedoms
     that the software does.  But this License is not limited to
     software manuals; it can be used for any textual work, regardless
     of subject matter or whether it is published as a printed book.
     We recommend this License principally for works whose purpose is
     instruction or reference.

  1. APPLICABILITY AND DEFINITIONS

     This License applies to any manual or other work, in any medium,
     that contains a notice placed by the copyright holder saying it
     can be distributed under the terms of this License.  Such a notice
     grants a world-wide, royalty-free license, unlimited in duration,
     to use that work under the conditions stated herein.  The
     "Document", below, refers to any such manual or work.  Any member
     of the public is a licensee, and is addressed as "you".  You
     accept the license if you copy, modify or distribute the work in a
     way requiring permission under copyright law.

     A "Modified Version" of the Document means any work containing the
     Document or a portion of it, either copied verbatim, or with
     modifications and/or translated into another language.

     A "Secondary Section" is a named appendix or a front-matter section
     of the Document that deals exclusively with the relationship of the
     publishers or authors of the Document to the Document's overall
     subject (or to related matters) and contains nothing that could
     fall directly within that overall subject.  (Thus, if the Document
     is in part a textbook of mathematics, a Secondary Section may not
     explain any mathematics.)  The relationship could be a matter of
     historical connection with the subject or with related matters, or
     of legal, commercial, philosophical, ethical or political position
     regarding them.

     The "Invariant Sections" are certain Secondary Sections whose
     titles are designated, as being those of Invariant Sections, in
     the notice that says that the Document is released under this
     License.  If a section does not fit the above definition of
     Secondary then it is not allowed to be designated as Invariant.
     The Document may contain zero Invariant Sections.  If the Document
     does not identify any Invariant Sections then there are none.

     The "Cover Texts" are certain short passages of text that are
     listed, as Front-Cover Texts or Back-Cover Texts, in the notice
     that says that the Document is released under this License.  A
     Front-Cover Text may be at most 5 words, and a Back-Cover Text may
     be at most 25 words.

     A "Transparent" copy of the Document means a machine-readable copy,
     represented in a format whose specification is available to the
     general public, that is suitable for revising the document
     straightforwardly with generic text editors or (for images
     composed of pixels) generic paint programs or (for drawings) some
     widely available drawing editor, and that is suitable for input to
     text formatters or for automatic translation to a variety of
     formats suitable for input to text formatters.  A copy made in an
     otherwise Transparent file format whose markup, or absence of
     markup, has been arranged to thwart or discourage subsequent
     modification by readers is not Transparent.  An image format is
     not Transparent if used for any substantial amount of text.  A
     copy that is not "Transparent" is called "Opaque".

     Examples of suitable formats for Transparent copies include plain
     ASCII without markup, Texinfo input format, LaTeX input format,
     SGML or XML using a publicly available DTD, and
     standard-conforming simple HTML, PostScript or PDF designed for
     human modification.  Examples of transparent image formats include
     PNG, XCF and JPG.  Opaque formats include proprietary formats that
     can be read and edited only by proprietary word processors, SGML or
     XML for which the DTD and/or processing tools are not generally
     available, and the machine-generated HTML, PostScript or PDF
     produced by some word processors for output purposes only.

     The "Title Page" means, for a printed book, the title page itself,
     plus such following pages as are needed to hold, legibly, the
     material this License requires to appear in the title page.  For
     works in formats which do not have any title page as such, "Title
     Page" means the text near the most prominent appearance of the
     work's title, preceding the beginning of the body of the text.

     A section "Entitled XYZ" means a named subunit of the Document
     whose title either is precisely XYZ or contains XYZ in parentheses
     following text that translates XYZ in another language.  (Here XYZ
     stands for a specific section name mentioned below, such as
     "Acknowledgements", "Dedications", "Endorsements", or "History".)
     To "Preserve the Title" of such a section when you modify the
     Document means that it remains a section "Entitled XYZ" according
     to this definition.

     The Document may include Warranty Disclaimers next to the notice
     which states that this License applies to the Document.  These
     Warranty Disclaimers are considered to be included by reference in
     this License, but only as regards disclaiming warranties: any other
     implication that these Warranty Disclaimers may have is void and
     has no effect on the meaning of this License.

  2. VERBATIM COPYING

     You may copy and distribute the Document in any medium, either
     commercially or noncommercially, provided that this License, the
     copyright notices, and the license notice saying this License
     applies to the Document are reproduced in all copies, and that you
     add no other conditions whatsoever to those of this License.  You
     may not use technical measures to obstruct or control the reading
     or further copying of the copies you make or distribute.  However,
     you may accept compensation in exchange for copies.  If you
     distribute a large enough number of copies you must also follow
     the conditions in section 3.

     You may also lend copies, under the same conditions stated above,
     and you may publicly display copies.

  3. COPYING IN QUANTITY

     If you publish printed copies (or copies in media that commonly
     have printed covers) of the Document, numbering more than 100, and
     the Document's license notice requires Cover Texts, you must
     enclose the copies in covers that carry, clearly and legibly, all
     these Cover Texts: Front-Cover Texts on the front cover, and
     Back-Cover Texts on the back cover.  Both covers must also clearly
     and legibly identify you as the publisher of these copies.  The
     front cover must present the full title with all words of the
     title equally prominent and visible.  You may add other material
     on the covers in addition.  Copying with changes limited to the
     covers, as long as they preserve the title of the Document and
     satisfy these conditions, can be treated as verbatim copying in
     other respects.

     If the required texts for either cover are too voluminous to fit
     legibly, you should put the first ones listed (as many as fit
     reasonably) on the actual cover, and continue the rest onto
     adjacent pages.

     If you publish or distribute Opaque copies of the Document
     numbering more than 100, you must either include a
     machine-readable Transparent copy along with each Opaque copy, or
     state in or with each Opaque copy a computer-network location from
     which the general network-using public has access to download
     using public-standard network protocols a complete Transparent
     copy of the Document, free of added material.  If you use the
     latter option, you must take reasonably prudent steps, when you
     begin distribution of Opaque copies in quantity, to ensure that
     this Transparent copy will remain thus accessible at the stated
     location until at least one year after the last time you
     distribute an Opaque copy (directly or through your agents or
     retailers) of that edition to the public.

     It is requested, but not required, that you contact the authors of
     the Document well before redistributing any large number of
     copies, to give them a chance to provide you with an updated
     version of the Document.

  4. MODIFICATIONS

     You may copy and distribute a Modified Version of the Document
     under the conditions of sections 2 and 3 above, provided that you
     release the Modified Version under precisely this License, with
     the Modified Version filling the role of the Document, thus
     licensing distribution and modification of the Modified Version to
     whoever possesses a copy of it.  In addition, you must do these
     things in the Modified Version:

       A. Use in the Title Page (and on the covers, if any) a title
          distinct from that of the Document, and from those of
          previous versions (which should, if there were any, be listed
          in the History section of the Document).  You may use the
          same title as a previous version if the original publisher of
          that version gives permission.

       B. List on the Title Page, as authors, one or more persons or
          entities responsible for authorship of the modifications in
          the Modified Version, together with at least five of the
          principal authors of the Document (all of its principal
          authors, if it has fewer than five), unless they release you
          from this requirement.

       C. State on the Title page the name of the publisher of the
          Modified Version, as the publisher.

       D. Preserve all the copyright notices of the Document.

       E. Add an appropriate copyright notice for your modifications
          adjacent to the other copyright notices.

       F. Include, immediately after the copyright notices, a license
          notice giving the public permission to use the Modified
          Version under the terms of this License, in the form shown in
          the Addendum below.

       G. Preserve in that license notice the full lists of Invariant
          Sections and required Cover Texts given in the Document's
          license notice.

       H. Include an unaltered copy of this License.

       I. Preserve the section Entitled "History", Preserve its Title,
          and add to it an item stating at least the title, year, new
          authors, and publisher of the Modified Version as given on
          the Title Page.  If there is no section Entitled "History" in
          the Document, create one stating the title, year, authors,
          and publisher of the Document as given on its Title Page,
          then add an item describing the Modified Version as stated in
          the previous sentence.

       J. Preserve the network location, if any, given in the Document
          for public access to a Transparent copy of the Document, and
          likewise the network locations given in the Document for
          previous versions it was based on.  These may be placed in
          the "History" section.  You may omit a network location for a
          work that was published at least four years before the
          Document itself, or if the original publisher of the version
          it refers to gives permission.

       K. For any section Entitled "Acknowledgements" or "Dedications",
          Preserve the Title of the section, and preserve in the
          section all the substance and tone of each of the contributor
          acknowledgements and/or dedications given therein.

       L. Preserve all the Invariant Sections of the Document,
          unaltered in their text and in their titles.  Section numbers
          or the equivalent are not considered part of the section
          titles.

       M. Delete any section Entitled "Endorsements".  Such a section
          may not be included in the Modified Version.

       N. Do not retitle any existing section to be Entitled
          "Endorsements" or to conflict in title with any Invariant
          Section.

       O. Preserve any Warranty Disclaimers.

     If the Modified Version includes new front-matter sections or
     appendices that qualify as Secondary Sections and contain no
     material copied from the Document, you may at your option
     designate some or all of these sections as invariant.  To do this,
     add their titles to the list of Invariant Sections in the Modified
     Version's license notice.  These titles must be distinct from any
     other section titles.

     You may add a section Entitled "Endorsements", provided it contains
     nothing but endorsements of your Modified Version by various
     parties--for example, statements of peer review or that the text
     has been approved by an organization as the authoritative
     definition of a standard.

     You may add a passage of up to five words as a Front-Cover Text,
     and a passage of up to 25 words as a Back-Cover Text, to the end
     of the list of Cover Texts in the Modified Version.  Only one
     passage of Front-Cover Text and one of Back-Cover Text may be
     added by (or through arrangements made by) any one entity.  If the
     Document already includes a cover text for the same cover,
     previously added by you or by arrangement made by the same entity
     you are acting on behalf of, you may not add another; but you may
     replace the old one, on explicit permission from the previous
     publisher that added the old one.

     The author(s) and publisher(s) of the Document do not by this
     License give permission to use their names for publicity for or to
     assert or imply endorsement of any Modified Version.

  5. COMBINING DOCUMENTS

     You may combine the Document with other documents released under
     this License, under the terms defined in section 4 above for
     modified versions, provided that you include in the combination
     all of the Invariant Sections of all of the original documents,
     unmodified, and list them all as Invariant Sections of your
     combined work in its license notice, and that you preserve all
     their Warranty Disclaimers.

     The combined work need only contain one copy of this License, and
     multiple identical Invariant Sections may be replaced with a single
     copy.  If there are multiple Invariant Sections with the same name
     but different contents, make the title of each such section unique
     by adding at the end of it, in parentheses, the name of the
     original author or publisher of that section if known, or else a
     unique number.  Make the same adjustment to the section titles in
     the list of Invariant Sections in the license notice of the
     combined work.

     In the combination, you must combine any sections Entitled
     "History" in the various original documents, forming one section
     Entitled "History"; likewise combine any sections Entitled
     "Acknowledgements", and any sections Entitled "Dedications".  You
     must delete all sections Entitled "Endorsements."

  6. COLLECTIONS OF DOCUMENTS

     You may make a collection consisting of the Document and other
     documents released under this License, and replace the individual
     copies of this License in the various documents with a single copy
     that is included in the collection, provided that you follow the
     rules of this License for verbatim copying of each of the
     documents in all other respects.

     You may extract a single document from such a collection, and
     distribute it individually under this License, provided you insert
     a copy of this License into the extracted document, and follow
     this License in all other respects regarding verbatim copying of
     that document.

  7. AGGREGATION WITH INDEPENDENT WORKS

     A compilation of the Document or its derivatives with other
     separate and independent documents or works, in or on a volume of
     a storage or distribution medium, is called an "aggregate" if the
     copyright resulting from the compilation is not used to limit the
     legal rights of the compilation's users beyond what the individual
     works permit.  When the Document is included in an aggregate, this
     License does not apply to the other works in the aggregate which
     are not themselves derivative works of the Document.

     If the Cover Text requirement of section 3 is applicable to these
     copies of the Document, then if the Document is less than one half
     of the entire aggregate, the Document's Cover Texts may be placed
     on covers that bracket the Document within the aggregate, or the
     electronic equivalent of covers if the Document is in electronic
     form.  Otherwise they must appear on printed covers that bracket
     the whole aggregate.

  8. TRANSLATION

     Translation is considered a kind of modification, so you may
     distribute translations of the Document under the terms of section
     4.  Replacing Invariant Sections with translations requires special
     permission from their copyright holders, but you may include
     translations of some or all Invariant Sections in addition to the
     original versions of these Invariant Sections.  You may include a
     translation of this License, and all the license notices in the
     Document, and any Warranty Disclaimers, provided that you also
     include the original English version of this License and the
     original versions of those notices and disclaimers.  In case of a
     disagreement between the translation and the original version of
     this License or a notice or disclaimer, the original version will
     prevail.

     If a section in the Document is Entitled "Acknowledgements",
     "Dedications", or "History", the requirement (section 4) to
     Preserve its Title (section 1) will typically require changing the
     actual title.

  9. TERMINATION

     You may not copy, modify, sublicense, or distribute the Document
     except as expressly provided for under this License.  Any other
     attempt to copy, modify, sublicense or distribute the Document is
     void, and will automatically terminate your rights under this
     License.  However, parties who have received copies, or rights,
     from you under this License will not have their licenses
     terminated so long as such parties remain in full compliance.

 10. FUTURE REVISIONS OF THIS LICENSE

     The Free Software Foundation may publish new, revised versions of
     the GNU Free Documentation License from time to time.  Such new
     versions will be similar in spirit to the present version, but may
     differ in detail to address new problems or concerns.  See
     `http://www.gnu.org/copyleft/'.

     Each version of the License is given a distinguishing version
     number.  If the Document specifies that a particular numbered
     version of this License "or any later version" applies to it, you
     have the option of following the terms and conditions either of
     that specified version or of any later version that has been
     published (not as a draft) by the Free Software Foundation.  If
     the Document does not specify a version number of this License,
     you may choose any version ever published (not as a draft) by the
     Free Software Foundation.

C.0.1 ADDENDUM: How to use this License for your documents
----------------------------------------------------------

To use this License in a document you have written, include a copy of
the License in the document and put the following copyright and license
notices just after the title page:

       Copyright (C)  YEAR  YOUR NAME.
       Permission is granted to copy, distribute and/or modify this document
       under the terms of the GNU Free Documentation License, Version 1.2
       or any later version published by the Free Software Foundation;
       with no Invariant Sections, no Front-Cover Texts, and no Back-Cover Texts.
       A copy of the license is included in the section entitled ``GNU
       Free Documentation License''.

   If you have Invariant Sections, Front-Cover Texts and Back-Cover
Texts, replace the "with...Texts." line with this:

         with the Invariant Sections being LIST THEIR TITLES, with
         the Front-Cover Texts being LIST, and with the Back-Cover Texts
         being LIST.

   If you have Invariant Sections without Cover Texts, or some other
combination of the three, merge those two alternatives to suit the
situation.

   If your document contains nontrivial examples of program code, we
recommend releasing these examples in parallel under your choice of
free software license, such as the GNU General Public License, to
permit their use in free software.